/*
 * SpriteEngine.java
 *
 * Created: July 7, 2007, 2:57 PM
 * Author: Stephen Whitmore
 *
 */
package irrtum.game;

import java.util.*;

/**
 * Manages and maintains all Sprite objects in the game; their updates, drawing,
 * and collisions.
 *
 */
public class EntityEngine
{
    static ArrayList<Entity> entities, toAdd, toRemove;
    
    static
    {
        entities = new ArrayList<Entity>();
        toAdd = new ArrayList<Entity>();
        toRemove = new ArrayList<Entity>();
    }
    
    public static void update()
    {
        for(Entity entity : toAdd)
        {
            entities.add(entity);
        }
        toAdd.clear();

        for(Entity entity : toRemove)
        {
            entities.remove(entity);
        }
        toRemove.clear();

        for(Entity entity : entities)
        {
            entity.update();
        }
    }

    public static void doCollisions()
    {
    }

    public static void render(Camera camera)
    {
        for(Entity entity : entities)
        {
            entity.render(camera);
        }
    }
    
    public static void addEntity(Entity entity)
    {
        toAdd.add(entity);
    }
    public static void removeEntity(Entity entity)
    {
        toRemove.add(entity);
    }
    
    public static void killAllEntities()
    {
        for(Entity entity : entities)
        {
            removeEntity(entity);
        }
    }
}
