/*
 * Sun.java
 *
 * Created: April 10, 2009, 2:15 PM
 * Author: Stephen Whitmore
 *
 */
package irrtum.map;

import irrtum.engine.*;
import org.lwjgl.opengl.*;
import java.nio.*;
import org.lwjgl.BufferUtils;


public class Sun
{
    static Vector3 diffuse, ambient;
    static Vector3 dir;

    static
    {
        diffuse = new Vector3();
        ambient = new Vector3();
        dir = new Vector3();
    }

    public static void change(Vector3 diff, Vector3 amb, Vector3 d)
    {
        diffuse.set(diff);
        ambient.set(amb);
        dir.set(d);

        // Recalculate lighting for the world.
//        for(int i=0; i < Map.WORLD_SIZE; i++)
//        {
//            for(int j=0; j < Map.WORLD_SIZE; j++)
//            {
//                Chunk cell = Map.getCell(i,j);
//                if(cell != null)
//                    cell.recalculateLighting();
//            }
//        }
    }

    public static void setupLight()
    {
        FloatBuffer diff = BufferUtils.createFloatBuffer(4);
        diff.put(diffuse.x).put(diffuse.y).put(diffuse.z).put(1.0f).flip();
        //float diff[] = new float[4];
        //diff[0] = diffuse.x; diff[1] = diffuse.y; diff[2] = diffuse.z; diff[3] = 1.0f;
        FloatBuffer amb = BufferUtils.createFloatBuffer(4);
        amb.put(ambient.x).put(ambient.y).put(ambient.z).put(1.0f).flip();
        //float amb[] = new float[4];
        //amb[0] = ambient.x; amb[1] = ambient.y; amb[2] = ambient.z; amb[3] = 1.0f;
        FloatBuffer dirr = BufferUtils.createFloatBuffer(4);
        dirr.put(dir.x).put(dir.y).put(dir.z).put(0.0f).flip();
        //float d[] = new float[4];
        //d[0] = dir.x; d[1] = dir.y; d[2] = dir.z; d[3] = 0.0f;
        GL11.glLight(GL11.GL_LIGHT0, GL11.GL_DIFFUSE, diff);//FloatBuffer.wrap(diff));
        GL11.glLight(GL11.GL_LIGHT0, GL11.GL_AMBIENT, amb);//FloatBuffer.wrap(amb));
        GL11.glLight(GL11.GL_LIGHT0, GL11.GL_POSITION, dirr);//FloatBuffer.wrap(d));
    }
}